#include <at89x51.h>

#define ADC_CS		P2_0
#define ADC_RD		P2_1
#define ADC_WR		P2_2
#define ADC_PORT	P1

__bit adc_busy;

unsigned char adc(void)
{
unsigned char adc_data;
ADC_CS=0;ADC_WR=0;ADC_WR=1;ADC_CS=1;
while(adc_busy==1);
ADC_CS=0;ADC_RD=0;adc_data=ADC_PORT;ADC_RD=1;ADC_CS=1;
return adc_data;
}

void INT0_ISR(void) __interrupt 0
{
adc_busy=0;
}

void main(void)
{
unsigned char sm_position=128;
unsigned char adc_data=128;
unsigned char sm_control=0x01;
unsigned int  i;

EX0=1;EA=1;
while(1==1)
	{
	if(adc_data<sm_position)
		{
		sm_control*=2;if(sm_control>8)sm_control=1;sm_position--;if(sm_position==255)sm_position=0;
		}
	else if(adc_data>sm_position)
		{
		sm_control/=2;if(sm_control==0)sm_control=8;sm_position++;if(sm_position==0)sm_position=255;
		}
	P0=sm_control;
	for(i=0;i<50;i++);
	adc_busy=1;adc_data=adc();
	}
}

